# -- coding: utf-8 --
# -- code by virtualstuff --
# -- version 2.1 --

msfs_mode = 1
icao="ebbr"

@AlternativeStopPositions
def customOffsetApronNorth1_walk(aircraftData):
        table = {
                0: 0.00,
                319: 0.70,
                320: 0.70,
                321: 0.70,
                330: 7.90,
                350: 11.10,
                737: 0.00,            
                175: 0.70,
                190: 0.80,
                290: 0.80,
                295: 0.80,
        }
        table737 = {
                0: 0.00,
                600: 0.70,
                700: 0.70,
                800: 0.70,
                900: 0.70,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance()

@AlternativeStopPositions
def customOffsetApronNorth1(aircraftData):
        table = {
                0: 0.70,
                319: 0.70,
                320: 0.80,
                321: 0.80,
                330: 0.90,
                350: 0.60,
                737: 0.70,
                767: 0.60,
                777: 0.60,
                787: 0.60,
                175: -3.20,
                190: -2.10,
                290: -2.10,
                295: -2.10,
        }
        table737 = {
                0: 0.70,
                600: -3.20,
                700: -2.10,
                800: 0.70,
                900: 0.70,
        }
        table767 = {
                0: 0.60,
                300: 0.60,
                400: 0.60,
        }
        table777 = {
                0: 0.60,
                200: 0.60,
                300: 0.60,
        }
        
        table330 = {
                0: 0.60,
                200: 0.60,
                300: 0.60,
                800: 0.60,
                900: 0.60,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 330:
            return Distance.fromMeters( table330.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 767:
            return Distance.fromMeters( table767.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 777:
            return Distance.fromMeters( table777.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance() 
                
@AlternativeStopPositions
def customOffsetApronSouth1(aircraftData):
        table = {
                0: -2.10,
                319: -2.00,
                320: -2.00,
                321: -2.00,
                737: -2.10,
                175: -4.20,
                190: -4.10,
                195: -4.10,
                290: -4.10,
                295: -4.10,
        }
        table737 = {
                0: -2.10,
                600: -2.10,
                700: -2.10,
                800: -2.10,
                900: -2.10,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance() 
                
@AlternativeStopPositions
def customOffsetApronSouth1A(aircraftData):
        table = {
                0: -3.00,
                319: -6.00,
                320: -6.00,
                321: -6.00,
                737: -3.00,
                175: -6.10,
                190: -8.10,
                195: -8.10,
                290: -8.10,
                295: -8.10,
        }
        table737 = {
                0: -3.00,
                600: -6.10,
                700: -6.10,
                800: -3.00,
                900: -3.00,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance() 

@AlternativeStopPositions
def customOffsetApronSouth1B(aircraftData):
        table = {
                0: -9.10,
                319: -10.00,
                320: -9.00,
                321: -9.00,
                737: -9.10,
                175: -17.10,
                190: -16.10,
                195: -16.10,
                290: -16.10,
                295: -16.10,
        }
        table737 = {
                0: -9.10,
                600: -16.10,
                700: -10.10,
                800: -9.10,
                900: -9.10,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance()
                
@AlternativeStopPositions
def customOffsetApronSouth1C(aircraftData):
        table = {
                0: -2.10,
                319: -3.00,
                320: -2.00,
                321: -2.00,
                737: -2.10,
                175: -10.10,
                190: -9.10,
                195: -9.10,
                290: -9.10,
                295: -9.10,
        }
        table737 = {
                0: -2.10,
                600: -3.10,
                700: -3.10,
                800: -2.10,
                900: -2.10,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance()                 

@AlternativeStopPositions
def customOffsetApronSouth_H1(aircraftData):
        table = {
                0: 0.60,
                300: -7.20,
                319: -10.80,
                320: -10.80,
                321: -10.80,
                330: -7.20,
                350: -7.20,
                737: -11.00,
                767: 0.60,
                777: 0.60,
                787: 0.60,
                175: -11.30,
                190: -11.10,
                195: -11.10,
                290: -11.10,
                295: -11.10,
        }
        
        try:
            return Distance.fromMeters(table.get(aircraftData.idMajor))
        except:
            return Distance()
        
            return Distance.fromMeters(d)
            
@AlternativeStopPositions
def customOffsetApronNorth2(aircraftData):
        table = {
                0: 3.30,
                300: 0.00,
                319: 3.30,
                320: 3.30,
                321: 3.30,
                330: 0.00,
                350: 0.00,
                737: 3.20,
                767: 0.00,
                777: 0.00,
                787: 0.00,
                175: 0.00,
                190: 2.10,
                290: 2.10,
                295: 2.10,
        }
        table737 = {
                0: 3.20,
                600: 2.10,
                700: 2.10,
                800: 3.20,
                900: 3.20,
        }
        table767 = {
                0: 0.60,
                300: 0.60,
                400: 0.60,
        }
        table777 = {
                0: 0.60,
                200: 0.60,
                300: 0.60,
        }
        
        table330 = {
                0: 0.60,
                200: 0.60,
                300: 0.60,
                800: 0.60,
                900: 0.60,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 330:
            return Distance.fromMeters( table330.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 767:
            return Distance.fromMeters( table767.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 777:
            return Distance.fromMeters( table777.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance() 
                
@AlternativeStopPositions
def customOffsetApronNorth2A(aircraftData):
        table = {
                0: 2.50,
                300: 4.90,
                319: 3.90,
                320: 3.90,
                321: 3.90,
                330: 4.90,
                350: 4.90,
                737: 2.50,
                767: 4.90,
                777: 4.90,
                787: 4.90,
                175: 0.00,
                190: 1.10,
                290: 1.10,
                295: 1.10,
        }
        table737 = {
                0: 2.50,
                600: 1.10,
                700: 1.10,
                800: 2.50,
                900: 2.50,
        }
        table767 = {
                0: 4.90,
                300: 3.90,
                400: 4.90,
        }
        table777 = {
                0: 4.90,
                200: 3.90,
                300: 4.90,
        }
        
        table330 = {
                0: 3.90,
                200: 2.50,
                300: 2.50,
                800: 4.90,
                900: 4.90,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 330:
            return Distance.fromMeters( table330.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 767:
            return Distance.fromMeters( table767.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 777:
            return Distance.fromMeters( table777.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance() 

@AlternativeStopPositions
def customOffsetApronNorth2H(aircraftData):
        table = {
                0: 4.90,
                300: 4.90,
                319: 3.30,
                320: 3.30,
                321: 3.30,
                330: 4.90,
                350: 4.90,
                737: 3.20,
                767: 5.20,
                777: 5.20,
                787: 5.20,
                175: 0.00,
                190: 2.10,
                290: 2.10,
                295: 2.10,
        }
        table737 = {
                0: 3.20,
                600: 2.10,
                700: 2.10,
                800: 3.20,
                900: 3.20,
        }
        table767 = {
                0: 5.20,
                300: 5.20,
                400: 5.20,
        }
        table777 = {
                0: 5.20,
                200: 5.20,
                300: 5.20,
        }
        
        table330 = {
                0: 4.90,
                200: 4.90,
                300: 4.90,
                800: 4.90,
                900: 4.90,
        }
        
        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 330:
            return Distance.fromMeters( table330.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 767:
            return Distance.fromMeters( table767.get(aircraftData.idMinor))
        elif aircraftData.idMajor == 777:
            return Distance.fromMeters( table777.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance()

            
@AlternativeStopPositions
def customOffsetApron9CNorth(aircraftData):
        table = {
                0: -12.10,
                300: -12.10,
                319: -12.10,
                320: -12.10,
                321: -12.10,
                330: -12.10,
                350: 0.00,
                737: -12.10,
                767: 0.00,
                777: 0.00,
                787: 0.00,        
        }
        
        try:
            return Distance.fromMeters(table.get(aircraftData.idMajor))
        except:
            return Distance()
        
            return Distance.fromMeters(d) 

@AlternativeStopPositions
def customOffsetApron9C_2North(aircraftData):
        table = {
                0: -9.50,
                300: -9.50,
                319: -9.60,
                320: -9.60,
                321: -9.60,
                330: -9.50,
                350: 0.00,
                737: -9.60,
                767: 0.00,
                777: 0.00,
                787: 0.00,        
        }
        
        try:
            return Distance.fromMeters(table.get(aircraftData.idMajor))
        except:
            return Distance()
        
            return Distance.fromMeters(d)
            
@AlternativeStopPositions
def customOffsetApron9C_1North(aircraftData):
        table = {
                0: 0.00,
                300: 0.00,
                319: 0.00,
                320: 0.00,
                321: 0.00,
                330: 0.00,
                350: 0.00,
                737: 0.00,
                767: 0.00,
                777: 0.00,
                787: 0.00,        
        }
        
        try:
            return Distance.fromMeters(table.get(aircraftData.idMajor))
        except:
            return Distance()
        
            return Distance.fromMeters(d) 

@AlternativeStopPositions
def customOffsetApronSouth2A(aircraftData):
        table = {
                0: 0.00,
                300: 0.00,
                319: -3.00,
                320: -3.00,
                321: 0.00,
                330: 0.00,
                350: 0.00,
                737: -3.00,
                767: 0.00,
                777: 0.00,
                787: 0.00,
                175: -6.10,
                190: -6.10,
                195: -6.10,
                290: -6.10,
                295: -6.10,
        }
        table737 = {
                0: -3.20,
                600: -6.10,
                700: -6.10,
                800: -3.20,
                900: -3.20,
        } 

        if aircraftData.idMajor == 737:
            return Distance.fromMeters(table737.get(aircraftData.idMinor))
        else:
            try:
                return Distance.fromMeters(table.get(aircraftData.idMajor))
            except:
                return Distance()
                
@AlternativeStopPositions
def customOffsetApronSouth2H(aircraftData):
        table = {
                0: -3.30,
                300: -3.30,
                319: -5.80,
                320: -5.80,
                321: -5.80,
                330: -3.30,
                350: -3.30,
                737: -5.90,
                767: -0.20,
                777: -0.20,
                787: -0.20,
                175: -5.70,
                190: -5.70,
                195: -5.70,
                290: -5.70,
                295: -5.70,
        }
        try:
            return Distance.fromMeters(table.get(aircraftData.idMajor))
        except:
            return Distance()
        
            return Distance.fromMeters(d) 

def MyTerminalNames(name, letter, priority):
    return CustomizedName( "%s %s" % (name, letter), priority)
    
def StandName(name, letter, priority):
    return CustomizedName( "%s %s" % (name, letter), priority)

NorthStands_1 = MyTerminalNames("Apron 1 North | Stands #","",1)
NorthGates_1 = MyTerminalNames("Apron 1 North | Gate A #","",2)
NorthGates_H1 = MyTerminalNames("Apron 1 North | Gate A #","",2)
SouthGates_1 = MyTerminalNames("Apron 1 South | Gate A #","",3)
SouthGates_1R = MyTerminalNames("Apron 1 South | Gate A #R","",3)
SouthGates_H1 = MyTerminalNames("Apron 1 South | Gate A #","",3)
NorthGates_2 = MyTerminalNames("Apron 2 North | Gate B #","",4)
NorthGates_2L = MyTerminalNames("Apron 2 North | Gate B #L","",4)
NorthGates_2R = MyTerminalNames("Apron 2 North| Gate B #R","",4)
NorthGates_2H = MyTerminalNames("Apron 2 North| Gate B #","",4)
NorthGates_2HR = MyTerminalNames("Apron 2 North | Gate B #R","",4)
SouthGates_2 = MyTerminalNames("Apron 2 South | Gate B #","",5)
SouthGates_2R = MyTerminalNames("Apron 2 South | Gate B #R","",5)
SouthGates_2H = MyTerminalNames("Apron 2 South | Gate B #","",5)
SouthGates_2HR = MyTerminalNames("Apron 2 South | Gate B #R","",5)
SouthGates_2HL = MyTerminalNames("Apron 2 South | Gate B #L","",5)
SouthGates_2A320 = MyTerminalNames("Apron 2 South only A320/A20N | Gate B #","",6)
NorthGates_2D = MyTerminalNames("Apron 2 North maintenance walk in | Gate B #","",7)
SouthGates_2D = MyTerminalNames("Apron 2 South maintenance walk in | Gate B #","",8)
SateliteStands_3 = MyTerminalNames("Apron Satelite | Stands #","",9)
NorthStands_3 = MyTerminalNames("Apron 3 North | Stands #","",10)
SouthStands_3 = MyTerminalNames("Apron 3 South | Stands #","",11)
Apron40_Stands = MyTerminalNames("Apron 40 | Stands #","",12)
CargoApron9North = StandName("Apron 9 North Cargo | Stands #","",13)
SateliteStands_3N = MyTerminalNames("Apron Satelite disabled | Stands #","",14)
NorthStands_3N = MyTerminalNames("Apron 3 North for deicing only | Stands #","",15)

parkings = {
        GATE : {
            None : (),
                120 : (NorthStands_1, customOffsetApronNorth1_walk),
                122 : (NorthStands_1, customOffsetApronNorth1_walk),
                126 : (NorthStands_1, customOffsetApronNorth1_walk), 
                134 : (NorthStands_1, customOffsetApronNorth1_walk), 
                136 : (NorthStands_1, customOffsetApronNorth1_walk),
                138 : (NorthStands_1, customOffsetApronNorth1_walk),
                140 : (NorthGates_1, customOffsetApronNorth1),
                142 : (NorthGates_1, customOffsetApronNorth1),
                143 : (SouthGates_1, customOffsetApronSouth1A),
                144 : (NorthGates_1, customOffsetApronNorth1),
                145 : (SouthGates_1R, customOffsetApronSouth1A),
                146 : (NorthGates_1, customOffsetApronNorth1),
                147 : (SouthGates_1, customOffsetApronSouth1A),
                148 : (NorthGates_1, customOffsetApronNorth1),
                149 : (SouthGates_1R, customOffsetApronSouth1A),
                150 : (NorthGates_1, customOffsetApronNorth1),
                152 : (NorthGates_1, customOffsetApronNorth1),
                153 : (SouthGates_1R, customOffsetApronSouth1A),
                154 : (NorthGates_1, customOffsetApronNorth1),
                151 : (SouthGates_1, customOffsetApronSouth1),
                155 : (SouthGates_1, customOffsetApronSouth1A),
                156 : (NorthGates_1, customOffsetApronNorth1),
                157 : (SouthGates_1R, customOffsetApronSouth1A),
                158 : (NorthGates_1, customOffsetApronNorth1),
                159 : (SouthGates_1, customOffsetApronSouth1C),
                160 : (NorthGates_1, customOffsetApronNorth1),
                161 : (SouthGates_1, customOffsetApronSouth1B),
                162 : (NorthGates_1, customOffsetApronNorth1),
                163 : (SouthGates_1, customOffsetApronSouth1A),
                164 : (NorthGates_1, customOffsetApronNorth1),
                165 : (SouthGates_1R, customOffsetApronSouth1A),
                166 : (NorthGates_1, customOffsetApronNorth1),
                167 : (SouthGates_1, customOffsetApronSouth1A),
                168 : (NorthGates_1, customOffsetApronNorth1),
                169 : (SouthGates_1R, customOffsetApronSouth1),
                170 : (NorthGates_1, customOffsetApronNorth1),
                171 : (SouthGates_H1, customOffsetApronSouth_H1),
                172 : (NorthGates_1, customOffsetApronNorth1),
                174 : (NorthGates_H1, customOffsetApronNorth1),
                201 : (SouthGates_2D, ),
                203 : (SouthGates_2D, ),
                204 : (NorthGates_2H, customOffsetApronNorth2H),
                205 : (SouthGates_2HL, customOffsetApronSouth2A),
                206 : (NorthGates_2L, ),
                207 : (SouthGates_2, customOffsetApronSouth2H),
                208 : (NorthGates_2D, customOffsetApronNorth2),
                209 : (SouthGates_2D, ),
                210 : (NorthGates_2R, customOffsetApronNorth2),
                211 : (SouthGates_2HR, customOffsetApronSouth2H),
                214 : (NorthGates_2H, customOffsetApronNorth2H),
                215 : (SouthGates_2D, ),
                217 : (SouthGates_2HR, customOffsetApronSouth2H),
                227 : (SouthGates_2D, ),
                228 : (NorthGates_2H, customOffsetApronNorth2H),
                229 : (SouthGates_2HR, customOffsetApronSouth2A),
                230 : (NorthGates_2HR, customOffsetApronNorth2A),
                231 : (SouthGates_2A320, ),
                232 : (NorthGates_2D, ),
                233 : (SouthGates_2R, customOffsetApronSouth2H),
                234 : (NorthGates_2R, customOffsetApronNorth2),
                236 : (NorthGates_2, customOffsetApronNorth2A),
                237 : (SouthGates_2HL, customOffsetApronSouth2H),
                238 : (NorthGates_2H, customOffsetApronNorth2H),
                240 : (NorthGates_2H, customOffsetApronNorth2H),
                304 : (SateliteStands_3, ),
                306 : (SateliteStands_3N, ),
                305 : (SateliteStands_3N, ),
                312 : (NorthStands_3, ),
                316 : (NorthStands_3, ),
                324 : (NorthStands_3, ),
                313 : (SouthStands_3, ),
                317 : (SouthStands_3, ),
                321 : (SouthStands_3, ),
                323 : (SouthStands_3, ),
                326 : (NorthStands_3N, ),
                330 : (NorthStands_3N, ),
                354 : (SateliteStands_3, ),
                421 : (Apron40_Stands, ),
                422 : (Apron40_Stands, ),
                423 : (Apron40_Stands, ),
                431 : (Apron40_Stands, ),
                432 : (Apron40_Stands, ),
                433 : (Apron40_Stands, ),
                441 : (Apron40_Stands, ),
                442 : (Apron40_Stands, ),
                443 : (Apron40_Stands, ),
    },
        PARKING : {
            None : ( ),
                951 : (CargoApron9North, customOffsetApron9C_1North),
                954 : (CargoApron9North, customOffsetApron9C_1North),
                957 : (CargoApron9North, customOffsetApron9CNorth),
                959 : (CargoApron9North, customOffsetApron9CNorth),
                960 : (CargoApron9North, customOffsetApron9C_1North),
                961 : (CargoApron9North, customOffsetApron9CNorth),
                962 : (CargoApron9North, customOffsetApron9C_1North),
                963 : (CargoApron9North, customOffsetApron9CNorth),
                964 : (CargoApron9North, customOffsetApron9C_1North),
                965 : (CargoApron9North, customOffsetApron9CNorth),
                966 : (CargoApron9North, customOffsetApron9C_1North),
                967 : (CargoApron9North, customOffsetApron9C_2North),
                969 : (CargoApron9North, customOffsetApron9C_2North),
                971 : (CargoApron9North, customOffsetApron9C_1North),
    },
}